#include "testlib.h"
#include <iostream>
#include <numeric>
using namespace std;

char GenFromDistribution(const vector<int>& dist) {
    int sum = accumulate(dist.begin(), dist.end(), 0);
    int x = rnd.next(1, sum);
    for (int i = 0; i < dist.size(); ++i) {
        if (dist[i] >= x) return 'a' + i;
        x -= dist[i];
    }
    // It never returns here.
    return 'z';
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    println(n);
    int cnt = atoi(argv[2]);

    vector<int> dist(cnt);

    for (int i = 0; i < cnt; ++i) {
        dist[i] = atoi(argv[i + 3]);
    }

    string s;
    for (int i = 0; i < n; ++i) {
        s += GenFromDistribution(dist);
    }

    println(s);
    return 0;
}
