#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <sstream>
#include <deque>
#include <queue>
#include <random>
#include <cassert>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define FIXED cout << fixed << setprecision(12)
#define RANDOM srand(94385)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define f first
#define s second
#define hashmap unordered_map
#define hashset unordered_set
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) signed(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.f >> p.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline T sorted(T a) { sort(a); return a; }

const int N = 2e6 + 100;

struct Fenv {
    int fenv[N];
    void add(int r) {
        for (; r < N; r |= r + 1) fenv[r] += 1;
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1)
            ans += fenv[r];
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
} odd[2], even[2];

struct zet {
    int val;
    explicit operator int() { return val; }
    zet(ll x = 0) { val = (x > -mod && x < mod ? x : x % mod); if (val < 0) val += mod; }
    zet& operator+=(const zet &z) { val += z.val; if (val >= mod) val -= mod; return *this; }
    zet& operator-=(const zet &z) { val -= z.val; if (val < 0) val += mod; return *this; }
    zet& operator*=(const zet &z) { val = (val * (ll)z.val) % mod; return *this; }
    friend zet mpow(zet a, int n) {
        zet ans = 1;
        while (n > 0) {
            if (n & 1) ans *= a;
            a *= a;
            n >>= 1;
        }
        return ans;
    }
    zet inv() const { return mpow(*this, mod - 2); }
    zet& operator/=(const zet &z) { return *this *= z.inv(); }

    friend zet operator+(zet a, const zet &b) { return a += b; }
    friend zet operator-(zet a, const zet &b) { return a -= b; }
    friend zet operator*(zet a, const zet &b) { return a *= b; }
    friend zet operator/(zet a, const zet &b) { return a /= b; }
    bool operator==(const zet &z) { return val == z.val; }
    bool operator!=(const zet &z) { return val != z.val; }
    bool operator<(const zet &z) { return val < z.val; }

    friend istream& operator>>(istream& str, zet &z) {
        return str >> z.val;
    }
    friend ostream& operator<<(ostream& str, const zet &z) {
        return str << z.val;
    }
};

const zet p = 37;
zet pp[N];

struct strhash {
    vector<zet> h;
    strhash(string s) {
        zet curr = 0;
        for (auto i : s) {
            curr = curr * p + i;
            h.pb(curr);
        }
    }
    zet get(int l, int r) {
        return l == 0 ? h[r] : h[r] - h[l - 1] * pp[r - l + 1];
    }
};

signed main() {
    FAST; FIXED; RANDOM;
    pp[0] = 1;
    for (int i = 1; i < N; ++i) pp[i] = pp[i - 1] * p;
    int n;
    cin >> n;
    string s;
    cin >> s;
    string r = s;
    reverse(r);
    strhash hs(s), hr(r);
    auto pali = [&](int l, int r) {
        return hs.get(l, r) == hr.get(n - r - 1, n - l - 1);
    };
    vector<pair<pii, int>> segodd, segeven;
    for (int i = 0; i < sz(s); ++i) {
        int l = 0, r = min(i + 1, n - i);
        while (r - l > 1) {
            int mid = r + l >> 1;
            if (pali(i - mid, i + mid)) l = mid;
            else r = mid;
        }
        segodd.pb({{i - l, i + l}, i});
    }
    for (int i = 0; i + 1 < sz(s); ++i) {
        int l = -1, r = min(i + 1, n - i - 1);
        while (r - l > 1) {
            int mid = r + l >> 1;
            if (pali(i - mid, i + 1 + mid)) l = mid;
            else r = mid;
        }
        if (l != -1) {
            segeven.pb({{i - l, i + 1 + l}, i});
        }
    }
    sort(all(segodd), [](pair<pii, int> a, pair<pii, int> b) {
        return a.f.s - a.f.f > b.f.s - b.f.f;
    });
    sort(all(segeven), [](pair<pii, int> a, pair<pii, int> b) {
        return a.f.s - a.f.f > b.f.s - b.f.f;
    });
    ll ans = 0;
    for (auto seg : segodd) {
        int mxd = seg.f.s - seg.f.f + 1;
        int l = seg.s - mxd, r = seg.s + mxd;
        ans += odd[!(seg.s % 2)].get(l, r);
        odd[seg.s % 2].add(seg.s);
    }
    for (auto seg : segeven) {
        int mxd = seg.f.s - seg.f.f + 1;
        int l = seg.s - mxd, r = seg.s + mxd;
        ans += even[seg.s % 2].get(l, r);
        even[seg.s % 2].add(seg.s);
    }
    cout << ans;
    return 0;
}
