#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 500'000 + 10;


struct Fenw {
    vector<int> tree;

    Fenw(int n) : tree(n + 1) {}

    void add(int pos, int d) {
        for (; pos < tree.size(); pos |= pos + 1) {
            tree[pos] += d;
        }
    }

    int get(int l, int r) {
        if (l > r) return 0;
        return get(r) - get(l - 1);
    }

    int get(int pos) {
        int result = 0;
        for (; pos >= 0; pos = (pos & (pos + 1)) - 1) {
            result += tree[pos];
        }
        return result;
    }
};


int d1[MAXN];
int d2[MAXN];

int main() {
#ifdef DARKKEKS
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    string s;

    cin >> n >> s;

{
    int l = 0, r = -1;
    for (int i = 0; i < n; ++i) {
        int k = i > r ? 1 : min(d1[l + r - i], r - i + 1);
        while (i + k < n && i - k >= 0 && s[i + k] == s[i - k]) {
            ++k;
        }
        d1[i] = k;
        if (i + k - 1 > r) {
            l = i - k + 1, r = i + k - 1;
        }
    }
}
    
{
    int l = 0, r = -1;
    for (int i = 0; i < n; ++i) {
        int k = i > r ? 0 : min(d2[l + r - i + 1], r - i + 1);
        while (i - k - 1 >= 0 && i + k < n && s[i - k - 1] == s[i + k]) {
            k++;
        }
        d2[i] = k;
        if (i + k - 1 > r) {
            l = i - k, r = i + k - 1;
        }
    }
}

    // cout << s << "\n";

    // cout << "Odd:\n";
    // for (int i = 0; i < n; ++i) {
    //     cout << d1[i];
    // }
    // cout << "\n";
    
    // cout << "Even:\n";
    // for (int i = 0; i < n; ++i) {
    //     cout << d2[i];
    // }
    // cout << "\n";

    ll result = 0;

{
    // cout << "\nOdd:\n";
    Fenw v[2] = {Fenw(n), Fenw(n)};
    set<pair<int, int> > bounds;
    for (int i = 0; i < n; ++i) {
        while (bounds.size() && bounds.begin()->first < i) {
            auto it = *bounds.begin();
            bounds.erase(it);
            v[it.second & 1].add(it.second, -1);
        }
               
        int add = v[1 - (i & 1)].get(i - 2 * d1[i] + 1, i - 1);
        result += add;
        // cout << "Adding " << add << " in position " << i << "\n";

        int bound = i + 2 * d1[i] - 1;

        // cout << "Inserting bound {" << bound << ", " << i << "}\n";
        v[i & 1].add(i, 1);
        bounds.insert({bound, i});
    }
}

{
    // cout << "\nEven:\n";
    Fenw v[2] = {Fenw(n), Fenw(n)};
    set<pair<int, int> > bounds;
    for (int i = 0; i < n; ++i) {
        // cout << "i = " << i << ":\n";

        while (bounds.size() && bounds.begin()->first < i) {
            auto it = *bounds.begin();
            bounds.erase(it);
            v[it.second & 1].add(it.second, -1); 
            // cout << "v[" << (it.second & 1) << "].add(" << it.second << ", " << -1 << ")\n";
        }

        int add = v[i & 1].get(i - 2 * d2[i], i - 2);
        // cout << "get(" << i - 2 * d2[i] << ", " << i - 2 << ") = " << add << "\n";
        result += add;
        // cout << "Adding " << add << " in position " << i << "\n";

        int bound = i + 2 * d2[i];

        // cout << "Inserting bound {" << bound << ", " << i << "}, v[" << (i & 1) << "].add(" << i << ", " << 1 << ")\n";
        v[i & 1].add(i, 1);
        bounds.insert({bound, i});
    }
}

    cout << result << "\n";
}
