#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define mt make_tuple

typedef long long ll;
typedef long double ld;

#define next sdakjhfadskf

const int N = 500200;
const int MX = (int)(1e9) + 1000;

struct Fenwick{ ///[l, r)
    vector<int> t;
    int n;
    Fenwick(int x):n(x), t(x, 0) {}
    int query(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1)
        ans += t[r];
        return ans;
    }
    void modify(int i, int delta) {
        for (; i < n; i = (i | (i + 1)))
        t[i] += delta;
    }
    int query(int l, int r) {
        return query(r - 1) - query(l - 1);
    }
};

string s;
int n;
vector<int> p1(n), p2(n);

void calculate_pal(string v) {
    int n = v.size();
    int l = 0, r = -1;

    for (int i = 0; i < n; i++) {
        int k = (i > r ? 1 : min(p1[l + r - i], r - i + 1));
        while (i + k < n && i - k >= 0 && v[i + k] == v[i - k]) k++;
        p1[i] = k--;
        if (i + k > r) {
            l = i - k;
            r = i + k;
        }
    }
    l = 0;
    r = -1;
    for (int i = 0; i < n; i++) {
        int k = (i >= r ? 0 : min(p2[l + r - i - 1], r - i));
        while (i - k >= 0 && i + k + 1 < n && v[i - k] == v[i + k + 1]) k++;
        p2[i] = k--;
        if (i + k + 1 > r) {
            l = i - k;
            r = i + k + 1;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n;
    cin >> s;
    p1.resize(n);
    p2.resize(n);
    calculate_pal(s);
    
    long long ans = 0;
    {
        vector<tuple<int, int, int>> all;
        for (int i = 0; i < n; i++) {
            int l = i - p2[i] * 2;
            if (l > 0)
                all.push_back(make_tuple(l - 2, -1, i));
            all.push_back(make_tuple(i - 2, 1, i));
        }
        Fenwick F[2] = {Fenwick(N * 3), Fenwick(N * 3)};
        sort(all.begin(), all.end());
        int r = 0;
        for (auto it : all) {
            int p, mul, from;
            tie(p, mul, from) = it;
            while (r <= p) {
                F[r & 1].modify(r + p2[r] * 2, 1);
                r++;
            }
            ans += F[p & 1].query(from, F[p & 1].n) * mul;
        }
    }
    {
        vector<tuple<int, int, int>> all;
        for (int i = 0; i < n; i++) {
            int l = i - p1[i] * 2 + 1;
            if (l > 0)
                all.push_back(make_tuple(l - 2, -1, i));
            all.push_back(make_tuple(i - 1, 1, i));
        }
        Fenwick F[2] = {Fenwick(N * 3), Fenwick(N * 3)};
        sort(all.begin(), all.end());
        int r = 0;
        for (auto it : all) {
            int p, mul, from;
            tie(p, mul, from) = it;
            while (r <= p) {
                F[r & 1].modify(r + p1[r] * 2 - 1, 1);
                r++;
            }
            ans += F[p & 1].query(from, F[p & 1].n) * mul;
        }
    }

    cout << ans << endl;
#ifdef LOCAL
    cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
    return 0;
}
