#include <bits/stdc++.h>

using namespace std;

template<typename T>
struct fenwick{
    int n;
    vector<T> t;

    T sum(int r) {
        if (r < 0) return 0;
        r = min(r, n - 1);
        T ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) ans += t[r];
        return ans;
    }

    T sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }

    void inc(int x, T y) {
        for (; x < n; x |= x + 1) t[x] += y;
    }

    fenwick(int n): n(n), t(n, 0) {}
};

int main() {
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    string s;
    cin >> s;

    vector<int> p1(n);
    vector<int> p2(n);
    int l = 0, r = -1;
    for (int i = 0; i < n; i++) {
        int k = (i > r ? 1 : min(p1[l + r - i], r - i + 1));
        while (i + k < n && i - k >= 0 && s[i + k] == s[i - k]) k++;
        p1[i] = k--;
        if (i + k > r) {
            l = i - k;
            r = i + k;
        }
    }
    l = 0;
    r = -1;
    for (int i = 0; i < n; i++) {
        int k = (i >= r ? 0 : min(p2[l + r - i - 1], r - i));
        while (i - k >= 0 && i + k + 1 < n && s[i - k] == s[i + k + 1]) k++;
        p2[i] = k--;
        if (i + k + 1 > r) {
            l = i - k;
            r = i + k + 1;
        }
    }

    long long ans = 0;

{
    fenwick<int> f1(n), f2(n);

    vector<pair<int, int>> sg;

    for (int i = 0; i < n; i++) {
        int x = i;
        int len = p1[i];

        (x % 2 == 0 ? f2 : f1).inc(x, 1);
        sg.emplace_back(len, i);
    }

    sort(sg.begin(), sg.end());

    for (auto & [len, x] : sg) {
        (x % 2 == 0 ? f2 : f1).inc(x, -1);
        ans += (x % 2 == 1 ? f2 : f1).sum(x - len - len + 1, x + len + len - 1);
    }
}

{
    fenwick<int> f1(n), f2(n);

    vector<pair<int, int>> sg;

    for (int i = 0; i < n; i++) {
        int x = i;
        int len = p2[i];
        if (len < 1) {
            continue;
        }

        (x % 2 == 0 ? f2 : f1).inc(x, 1);
        sg.emplace_back(len, i);
    }

    sort(sg.begin(), sg.end());

    for (auto & [len, x] : sg) {
        (x % 2 == 0 ? f2 : f1).inc(x, -1);
        ans += (x % 2 == 0 ? f2 : f1).sum(x - len - len, x + len + len + 1);
    }
}

    // for (int i = 0; i < n; i++) {
    //     for (int len = 1; len <= p2[i]; len++) {
    //         int r = i + len + len;
    //         if (r >= n) break;

    //         if (p2[r] >= len) {
    //             ans++;
    //         }
    //     }
    // }

    cout << ans << endl;
}
