#include <bits/stdc++.h>

using namespace std;

const int N = 128;

struct PTree {
    struct Elem {
        Elem(int f, int s, Elem* l) : first(f), size(s), link(l) {
            next.fill(nullptr);
        }

        int first;
        int size;
        Elem* link;
        array<Elem*, 26> next;

        // Bitset stores all reachable sizes.
        bitset<N> reachable;
    };

    string s;
    vector<Elem> elems;
    vector<Elem*> largest;

    PTree(string str) : s(std::move(str)) {
        elems.reserve(s.size() + 2);
        elems.emplace_back(0, -1, nullptr);
        elems[0].link = &elems[0];
        elems.emplace_back(0, 0, &elems[0]);

        largest.reserve(s.size());

        Elem* cur = &elems[0];

        for (int i = 0; i < s.size(); ++i) {
            while (i - cur->size - 1 < 0 || s[i - cur->size - 1] != s[i]) {
                cur = cur->link;
            }
            if (!cur->next[s[i] - 'a']) {
                Elem* el = &elems.emplace_back(i - cur->size, cur->size + 2, nullptr);
                cur->next[s[i] - 'a'] = el;
                auto link = cur->link;
                if (el->size == 1) {
                    link = &elems[1];
                } else {
                    while (i - link->size - 1 < 0 || s[i - link->size - 1] != s[i]) {
                        link = link->link;
                    }
                    link = link->next[s[i] - 'a'];
                }
                el->link = link;
            }
            cur = cur->next[s[i] - 'a'];
            largest.push_back(cur);
        }
    }
};

long long getAnswer(PTree::Elem* a, PTree::Elem* b) {
    return (a->reachable & b->reachable).count();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    PTree p1(s);
    reverse(s.begin(), s.end());
    PTree p2(s);

    long long ans = 0;

    for (int i = 0; i <= n / N; ++i) {
        for (int j = 2; j < p1.elems.size(); ++j) {
            auto& el = p1.elems[j];
            el.reachable = el.link->reachable;
            if (i * N <= el.size && el.size < (i + 1) * N) {
                el.reachable.set(el.size - i * N);
            }
        }
        for (int j = 2; j < p2.elems.size(); ++j) {
            auto& el = p2.elems[j];
            el.reachable = el.link->reachable;
            if (i * N <= el.size && el.size < (i + 1) * N) {
                el.reachable.set(el.size - i * N);
            }
        }
        for (int i = 1; i < n; ++i) {
            ans += getAnswer(p1.largest[i - 1], p2.largest[n - 1 - i]);
        }
    }

    cout << ans << endl;
    return 0;
}
