#include <bits/stdc++.h>

using namespace std;

struct SegTree {

    void Build(const vector<int>& mas) {
        sz = 1;
        while (sz < mas.size()) sz *= 2;
        elems.clear();
        elems.resize(sz * 2);
        build(1, 0, sz - 1, mas);
    }

    int GetUpperCount(int border, int l, int r) {
        xl = l; xr = r; xval = border;
        return getUpperCount(1, 0, sz - 1);
    }

private:
    vector<vector<int>> elems;
    int sz;

    int xl, xr, xval;

    void build(int v, int l, int r, const vector<int> &mas) {
        if (l == r) {
            if (l < mas.size()) {
                elems[v].push_back(mas[l]);
            }
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m, mas);
        build(v * 2 + 1, m + 1, r, mas);
        merge(elems[v * 2].begin(), elems[v * 2].end(),
              elems[v * 2 + 1].begin(), elems[v * 2 + 1].end(),
              back_inserter(elems[v]));
    }

    int getUpperCount(int v, int l, int r) {
        if (xl <= l && r <= xr) {
            return elems[v].end() - lower_bound(elems[v].begin(), elems[v].end(), xval);
        }
        if (r < xl || xr < l) {
            return 0;
        }
        int m = (l + r) / 2;
        return getUpperCount(v * 2, l, m) + getUpperCount(v * 2 + 1, m + 1, r);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    string s;
    cin >> n >> s;

    int len, last;
    len = 0; last = -1;
    vector<int> even(n), odd(n);
    for (int i = 0; i < n; ++i) {
        int curR = 1;
        if (last > i) {
            curR = min(last - i, odd[last - len + (last - i) + 1]);
        }
        while (i + curR < n && i - curR >= 0 && s[i - curR] == s[i + curR]) {
            ++curR;
        }
        odd[i] = curR;
        if (i + curR - 1 > last) {
            last = i + curR - 1;
            len = curR * 2 - 1;
        }
    }

    last = - 1;
    len = 0;
    for (int i = 1; i < n; ++i) {
        int curR = 0;
        if (last > i) {
            curR = min(last - i, even[last - len + (last - i)]);
        }
        while (i + curR < n && i - curR - 1 >= 0 && s[i - curR - 1] == s[i + curR]) {
            ++curR;
        }
        even[i] = curR;
        if (i + curR > last) {
            last = i + curR;
            len = curR * 2;
        }
    }

    long long ans = 0;

    vector<int> transform1(even), transform2(odd);
    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            transform1[i] = odd[i] * 2 + i;
        } else {
            transform2[i] = odd[i] * 2 + i;
        }
    }
    SegTree f1, f2;
    f1.Build(transform1);
    f2.Build(transform2);

    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            ans += f2.GetUpperCount(i + 1, i - 2 * odd[i] + 1, i - 1);
        } else {
            ans += f1.GetUpperCount(i + 1, i - 2 * odd[i] + 1, i - 1);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            transform1[i] = even[i] * 2 + i;
        } else {
            transform2[i] = even[i] * 2 + i;
        }
    }
    f1.Build(transform1);
    f2.Build(transform2);

    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            ans += f1.GetUpperCount(i, i - 2 * even[i], i - 1);
        } else {
            ans += f2.GetUpperCount(i, i - 2 * even[i], i - 1);
        }
    }
   
    cout << ans << endl;
    return 0;
}
