#include <bits/stdc++.h>

using namespace std;

struct Fenwick {
    vector<int> sum;
    int allSum;

    void Build(int n) {
        sum.assign(n, 0);
        allSum = 0;
    }

    int GetPrefSum(int pos) {
        int result = 0;
        while (pos >= 0) {
            result += sum[pos];
            pos = (pos & (pos + 1)) - 1;
        }
        return result;
    }

    int GetSum() {
        return allSum;
    }

    void Add(int pos, int val) {
        allSum += val;
        while (pos < sum.size()) {
            sum[pos] += val;
            pos = (pos | (pos + 1));
        }
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    string s;
    cin >> n >> s;

    int len, last;
    len = 0; last = -1;
    vector<int> even(n), odd(n);
    for (int i = 0; i < n; ++i) {
        int curR = 1;
        if (last > i) {
            curR = min(last - i, odd[last - len + (last - i) + 1]);
        }
        while (i + curR < n && i - curR >= 0 && s[i - curR] == s[i + curR]) {
            ++curR;
        }
        odd[i] = curR;
        if (i + curR - 1 > last) {
            last = i + curR - 1;
            len = curR * 2 - 1;
        }
    }

    last = - 1;
    len = 0;
    for (int i = 1; i < n; ++i) {
        int curR = 0;
        if (last > i) {
            curR = min(last - i, even[last - len + (last - i)]);
        }
        while (i + curR < n && i - curR - 1 >= 0 && s[i - curR - 1] == s[i + curR]) {
            ++curR;
        }
        even[i] = curR;
        if (i + curR > last) {
            last = i + curR;
            len = curR * 2;
        }
    }

    long long ans = 0;

    Fenwick f1, f2;
    f1.Build(n);
    f2.Build(n);

    vector<vector<int>> expired(n);

    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            ans += f2.GetSum() - f2.GetPrefSum(i - 2 * odd[i]);
            f1.Add(i, 1);
        } else {
            ans += f1.GetSum() - f1.GetPrefSum(i - 2 * odd[i]);
            f2.Add(i, 1);
        }
        int exp = i + 2 * odd[i] - 1;
        if (exp < n) {
            expired[exp].push_back(i);
        }
        for (int exp : expired[i]) {
            if (exp & 1) {
                f1.Add(exp, -1);
            } else {
                f2.Add(exp, -1);
            }
        }
        expired[i].clear();
    }

    f1.Build(n);
    f2.Build(n);

    for (int i = 1; i < n; ++i) {
        if (i & 1) {
            ans += f1.GetSum() - f1.GetPrefSum(i - 2 * even[i] - 1);
            f1.Add(i, 1);
        } else {
            ans += f2.GetSum() - f2.GetPrefSum(i - 2 * even[i] - 1);
            f2.Add(i, 1);
        }
        int exp = i + 2 * even[i];
        if (exp < n) {
            expired[exp].push_back(i);
        }
        for (int exp : expired[i]) {
            if(exp & 1) {
                f1.Add(exp, -1);
            } else {
                f2.Add(exp, -1);
            }
        }
    }

    cout << ans << endl;
    return 0;
}
