#include <bits/stdc++.h>

using namespace std;

struct Hash {

    void Build(string s, int p, int mod) {
        hashes.resize(s.size() + 1);
        powp.resize(s.size() + 1);
        this->mod = mod;
        powp[0] = 1;
        for (int i = 1; i <= s.size(); ++i) {
            powp[i] = powp[i - 1] * 1ll * p % mod;
            hashes[i] = (hashes[i - 1] * 1ll * p + (s[i - 1] - 'a' + 1)) % mod;
        }
    }

    int GetHash(int l, int r) {
        return (hashes[r + 1] - hashes[l] * 1ll * powp[r - l + 1] % mod + mod) % mod;
    }

private:
    vector<int> hashes, powp;
    int mod;
};

const int P = 127;
const int MOD = 1'000'000'007;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    string s;
    cin >> n >> s;

    string r = s;
    reverse(r.begin(), r.end());
    Hash shash, rhash;
    shash.Build(s, P, MOD);
    rhash.Build(r, P, MOD);
    
    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int len = 2; i + len <= n; len += 2) {
            if (shash.GetHash(i, i + len / 2 - 1) == rhash.GetHash(n - (i + len / 2), n - 1 - i) &&
                shash.GetHash(i + len / 2, i + len - 1) == rhash.GetHash(n - (i + len), n - 1 - (i + len / 2)))
            {
                ++ans;
            }
        }
    }

    cout << ans << endl;
    return 0;
}
