#include <bits/stdc++.h>

using namespace std;


struct PTree {
    struct Elem {
        Elem(int f, int s, Elem* l) : first(f), size(s), link(l), cLink{nullptr, 0, 0} {
            next.fill(nullptr);
        }

        int first;
        int size;
        Elem* link;
        array<Elem*, 26> next;

        // Compressed link.
        struct {
            Elem* link;
            int delta;
            int count; 
        } cLink;
    };

    string s;
    vector<Elem> elems;
    vector<Elem*> largest;

    PTree(string str) : s(std::move(str)) {
        elems.reserve(s.size() + 2);
        elems.emplace_back(0, -1, nullptr);
        elems[0].link = &elems[0];
        elems.emplace_back(0, 0, &elems[0]);
        elems[0].cLink = elems[1].cLink = {&elems[0], -1, 0};

        largest.reserve(s.size());

        Elem* cur = &elems[0];

        for (int i = 0; i < s.size(); ++i) {
            while (i - cur->size - 1 < 0 || s[i - cur->size - 1] != s[i]) {
                cur = cur->link;
            }
            if (!cur->next[s[i] - 'a']) {
                Elem* el = &elems.emplace_back(i - cur->size, cur->size + 2, nullptr);
                cur->next[s[i] - 'a'] = el;
                auto link = cur->link;
                if (el->size == 1) {
                    link = &elems[1];
                } else {
                    while (i - link->size - 1 < 0 || s[i - link->size - 1] != s[i]) {
                        link = link->link;
                    }
                    link = link->next[s[i] - 'a'];
                }
                el->link = link;
                
                // Calculating cLink.
                if (el->size - link->size == link->cLink.delta) {
                    el->cLink = link->cLink;
                    ++el->cLink.count;
                } else {
                    el->cLink = {link, el->size - link->size, 1};
                }
            }
            cur = cur->next[s[i] - 'a'];
            largest.push_back(cur);
        }
    }
};

int extGcd(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    } else {
        int g = extGcd(b % a, a, y, x);
        x -= b / a * y;
        return g;
    }
}

int divFloor(long long a, long long b) {
    auto [x, r] = div(a, b);
    return x - (r < 0);
}

int intersect(int a0, int da, int n, int b0, int db, int m) {
    if (da < 0) {
        a0 += da * (n - 1);
        da = -da;
    }
    if (db < 0) {
        b0 += db * (m - 1);
        db = -db;
    }
    int right = min(a0 + da * (n - 1), b0 + db * (m - 1));
    int left = max(a0, b0);
    if (right < left) {
        return 0;
    }
    int x, y;
    int g = extGcd(da, db, x, y);
    if ((a0 - b0) % g != 0) {
        return 0;
    }
    long long point = b0 + (y * 1ll * (a0 - b0) / g) * db;
    long long delta = da / g * 1ll * db;
    return divFloor(right - point, delta) - divFloor(left - 1 - point, delta);
}

long long getAnswer(PTree::Elem* a, PTree::Elem* b) {
    long long result = 0;
    while (b->size > 0) {
        result += intersect(a->size, -a->cLink.delta, a->cLink.count,
                            b->size, -b->cLink.delta, b->cLink.count);

        if (a->cLink.link->size > b->cLink.link->size) {
            swap(a, b);
        }
        b = b->cLink.link;
    }
    return result;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    PTree p1(s);
    reverse(s.begin(), s.end());
    PTree p2(s);

    long long ans = 0;

    for (int i = 1; i < n; ++i) {
        ans += getAnswer(p1.largest[i - 1], p2.largest[n - 1 - i]);
    }

    cout << ans << endl;
    return 0;
}
