#include <bits/stdc++.h>

using namespace std;

struct SegTree {

    void Build(int n) {
        sz = 1;
        while (sz < n) sz *= 2;
        sum.assign(2 * sz, 0);
    }

    int GetPrefSum(int pos) {
        xr = pos;
        return getPrefSum(1, 0, sz - 1);
    }

    int GetSum() {
        return sum[1];
    }

    void Add(int pos, int val) {
        xr = pos, xval = val;
        add(1, 0, sz - 1);
    }

private:
    vector<int> sum;
    int sz;

    int xr, xval;

    int getPrefSum(int v, int l, int r) {
        if (r <= xr) {
            return sum[v];
        }
        if (l > xr) {
            return 0;
        }
        int m = (l + r) / 2;
        return getPrefSum(v * 2, l, m) + getPrefSum(v * 2 + 1, m + 1, r);
    }

    void add(int v, int l, int r) {
        if (l == r) {
            sum[v] += xval;
            return;
        }
        int m = (l + r) / 2;
        if (xr <= m) add(v * 2, l, m);
        else add(v * 2 + 1, m + 1, r);
        sum[v] = sum[v * 2] + sum[v * 2 + 1];
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    string s;
    cin >> n >> s;

    int len, last;
    len = 0; last = -1;
    vector<int> even(n), odd(n);
    for (int i = 0; i < n; ++i) {
        int curR = 1;
        if (last > i) {
            curR = min(last - i, odd[last - len + (last - i) + 1]);
        }
        while (i + curR < n && i - curR >= 0 && s[i - curR] == s[i + curR]) {
            ++curR;
        }
        odd[i] = curR;
        if (i + curR - 1 > last) {
            last = i + curR - 1;
            len = curR * 2 - 1;
        }
    }

    last = - 1;
    len = 0;
    for (int i = 1; i < n; ++i) {
        int curR = 0;
        if (last > i) {
            curR = min(last - i, even[last - len + (last - i)]);
        }
        while (i + curR < n && i - curR - 1 >= 0 && s[i - curR - 1] == s[i + curR]) {
            ++curR;
        }
        even[i] = curR;
        if (i + curR > last) {
            last = i + curR;
            len = curR * 2;
        }
    }

    long long ans = 0;

    SegTree f1, f2;
    f1.Build(n);
    f2.Build(n);

    vector<vector<int>> expired(n);

    for (int i = 0; i < n; ++i) {
        if (i & 1) {
            ans += f2.GetSum() - f2.GetPrefSum(i - 2 * odd[i]);
            f1.Add(i, 1);
        } else {
            ans += f1.GetSum() - f1.GetPrefSum(i - 2 * odd[i]);
            f2.Add(i, 1);
        }
        int exp = i + 2 * odd[i] - 1;
        if (exp < n) {
            expired[exp].push_back(i);
        }
        for (int exp : expired[i]) {
            if (exp & 1) {
                f1.Add(exp, -1);
            } else {
                f2.Add(exp, -1);
            }
        }
        expired[i].clear();
    }

    f1.Build(n);
    f2.Build(n);

    for (int i = 1; i < n; ++i) {
        if (i & 1) {
            ans += f1.GetSum() - f1.GetPrefSum(i - 2 * even[i] - 1);
            f1.Add(i, 1);
        } else {
            ans += f2.GetSum() - f2.GetPrefSum(i - 2 * even[i] - 1);
            f2.Add(i, 1);
        }
        int exp = i + 2 * even[i];
        if (exp < n) {
            expired[exp].push_back(i);
        }
        for (int exp : expired[i]) {
            if(exp & 1) {
                f1.Add(exp, -1);
            } else {
                f2.Add(exp, -1);
            }
        }
    }

    cout << ans << endl;
    return 0;
}
